"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Subject = void 0;

var _Subscription = require("./Subscription");

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var Subject =
/*#__PURE__*/
function () {
  function Subject() {
    _classCallCheck(this, Subject);

    this.next = this.next.bind(this);
    this.error = this.error.bind(this);
    this.complete = this.complete.bind(this);
    this.observers = [];
  }

  _createClass(Subject, [{
    key: "subscribe",
    value: function subscribe(observer) {
      var subscription = _Subscription.Subscription.createSimple(observer);

      this.observers.push(subscription.observer);
      return subscription;
    }
  }, {
    key: "unsubscribe",
    value: function unsubscribe() {
      this.cleanup(function (observer) {
        observer.cleanup();
        return false;
      });
    }
  }, {
    key: "cleanup",
    value: function cleanup(callback) {
      this.observers = this.observers.filter(function (observer) {
        if (!observer.isComplete) {
          var ret = callback(observer);

          if (typeof ret === 'boolean') {
            return ret;
          }

          return true;
        }

        return false;
      });
      return this;
    }
  }, {
    key: "next",
    value: function next(value) {
      this.cleanup(function (observer) {
        observer.onNext(value);
      });
    }
  }, {
    key: "error",
    value: function error() {
      for (var _len = arguments.length, errors = new Array(_len), _key = 0; _key < _len; _key++) {
        errors[_key] = arguments[_key];
      }

      this.cleanup(function (observer) {
        observer.onError.apply(observer, errors);
      });
    }
  }, {
    key: "complete",
    value: function complete() {
      this.cleanup(function (observer) {
        observer.onComplete();
      });
    }
  }]);

  return Subject;
}();

exports.Subject = Subject;