"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Subscription = void 0;

var _Observer = require("./Observer");

var _utilities = require("./utilities");

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

/**
 * @param {Function} callback
 * @param {{next: Function, error: Function, complete: Function}} observer
 */
var Subscription =
/*#__PURE__*/
function () {
  function Subscription() {
    var callback = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _utilities.noop;
    var observer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

    _classCallCheck(this, Subscription);

    this.observer = new _Observer.Observer(observer);
    this.observer.use(callback);
  }

  _createClass(Subscription, [{
    key: "unsubscribe",

    /**
     * Unsubscribe to the event stream
     *
     * @returns {void}
     */
    value: function unsubscribe() {
      this.observer.cleanup();
    }
    /**
     *
     * @returns {boolean}
     */

  }, {
    key: "isComplete",
    get: function get() {
      return this.observer.isComplete;
    }
  }, {
    key: "onNext",
    get: function get() {
      return this.observer.onNext;
    }
  }, {
    key: "onError",
    get: function get() {
      return this.observer.onError;
    }
  }, {
    key: "onComplete",
    get: function get() {
      return this.observer.onComplete;
    }
  }], [{
    key: "createSimple",
    value: function createSimple(observer) {
      return new Subscription(_utilities.noop, observer);
    }
  }]);

  return Subscription;
}();

exports.Subscription = Subscription;