"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.of = void 0;

var _Observable = require("../Observable");

/**
 * Takes any number of arguments and outputs them in order in an Observable stream
 *
 * @param {*[]} args
 * @returns {Observable}
 */
var of = function of() {
  for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
    args[_key] = arguments[_key];
  }

  return new _Observable.Observable(function (observer) {
    Array.from(args).forEach(function (value) {
      observer.next(value);
    });
    observer.complete();
  });
};

exports.of = of;
_Observable.Observable.of = of;