"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.range = void 0;

var _Observable = require("../Observable");

/**
 * Output a range of numbers to an Observable stream
 *
 * @param {Number} [start]
 * @param {Number} end
 * @returns {Observable}
 */
var range = function range() {
  var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
      _ref$start = _ref.start,
      start = _ref$start === void 0 ? 0 : _ref$start,
      end = _ref.end;

  return new _Observable.Observable(function (_ref2) {
    var next = _ref2.next,
        complete = _ref2.complete;

    for (var current = start; current <= end; ++current) {
      next(current);
    }

    complete();
  });
};

exports.range = range;
_Observable.Observable.range = range;