"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.filter = void 0;

var _Observable = require("../Observable");

var _passThroughNext = require("./passThroughNext");

/**
 * Will filter out values that you do not want to subscribe to
 *
 * @param {Observable} source$
 * @param {Function} filterCallback
 * @returns {Observable}
 */
var filter = function filter(source$, filterCallback) {
  return (0, _passThroughNext.passThroughNext)(source$, function (_ref, value) {
    var next = _ref.next;

    if (filterCallback(value)) {
      next(value);
    }
  });
};

exports.filter = filter;
_Observable.Observable.filter = filter;

_Observable.Observable.prototype.filter = function (filterCallback) {
  return filter(this, filterCallback);
};