"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.first = void 0;

var _Observable = require("../Observable");

var _take = require("./take");

/**
 * Will take the first value from the observable and then complete
 * This is an alias for `take(obs$, 1, callback)`
 *
 * @param {Observable} source$
 * @param {Function} [filterCallback] filter out values before taking the first one
 */
var first = function first(source$, filterCallback) {
  return (0, _take.take)(source$, 1, filterCallback);
};

exports.first = first;
_Observable.Observable.first = first;

_Observable.Observable.prototype.first = function (filterCallback) {
  return first(this, filterCallback);
};