"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.map = void 0;

var _Observable = require("../Observable");

var _passThroughNext = require("./passThroughNext");

/**
 * Will map each value to a new value using the callback
 *
 * @param {Observable} source$
 * @param {Function} mapCallback
 * @returns {Observable}
 */
var map = function map(source$, mapCallback) {
  return (0, _passThroughNext.passThroughNext)(source$, function (_ref, value) {
    var next = _ref.next;
    next(mapCallback(value));
  });
};

exports.map = map;
_Observable.Observable.map = map;

_Observable.Observable.prototype.map = function (mapCallback) {
  return map(this, mapCallback);
};