"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.min = void 0;

var _Observable = require("../Observable");

/**
 * Will result in the minimum value passed to the observer then will complete
 *
 * @param source$
 * @returns {Observable}
 */
var min = function min(source$) {
  return new _Observable.Observable(function (_ref) {
    var next = _ref.next,
        error = _ref.error,
        _complete = _ref.complete;
    var minNumber;
    var subscription = source$.subscribe({
      next: function next(value) {
        if (!minNumber || value < minNumber) {
          minNumber = value;
        }
      },
      error: error,
      complete: function complete() {
        next(minNumber);

        _complete();
      }
    });
    return function () {
      return subscription.unsubscribe();
    };
  });
};

exports.min = min;
_Observable.Observable.min = min;

_Observable.Observable.prototype.min = function () {
  return min(this);
};