"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.passThroughNextObservable = void 0;

var _passThroughNext = require("./passThroughNext");

var _utilities = require("../utilities");

var _of = require("../observables/of");

/**
 * @private
 * @param source$
 * @param mapCallback
 * @returns {Observable}
 */
var passThroughNextObservable = function passThroughNextObservable(source$, mapCallback) {
  return (0, _passThroughNext.passThroughNext)(source$, function (_ref, value) {
    var next = _ref.next;
    var nextValue$ = mapCallback(value);

    if (!(0, _utilities.isObservable)(nextValue$)) {
      nextValue$ = (0, _of.of)(nextValue$);
    }

    next(nextValue$);
  });
};

exports.passThroughNextObservable = passThroughNextObservable;