"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.sum = void 0;

var _Observable = require("../Observable");

var _reduce = require("./reduce");

/**
 * Sums all the values of an observable upon completion
 *
 * @param {Observable} source$
 */
var sum = function sum(source$) {
  return (0, _reduce.reduce)(source$, function (a, b) {
    return a + b;
  });
};

exports.sum = sum;
_Observable.Observable.sum = sum;

_Observable.Observable.prototype.sum = function () {
  return sum(this);
};